%debug
%error-verbose
%token EOF 0
%left PRIORITY2
%left PRIORITY1
%token NUMBER "number"
%token NEWLINE "newline"
%{
#include <stdlib.h>
int yylineno;
int rule = 0;

typedef struct { char *start; int len; } str;
str *mkstr(char *s, int l) { str *r = (str*) malloc(sizeof(str)); r->start = s; r->len = l; return r; }
void print_str(str *s) { 
	printf(", \"");
	while(s->len-->0) {
		unsigned char c = *s->start++;
		int i = (int) c;
		if(c == 0) printf("\\0");
		else if(c == 9) printf("\\t");
		else if(c == 10) printf("\\n");
		else if(c == 13) printf("\\r");
		else if(c == 34) printf("\\\"");
		else if(c < 32 || c > 126) printf("\\x%02x",c);
		else printf("%c",c);
	}
	printf("\"");
	free(s);
}
%}
%%

program : expr  { 
 printf("a%d = [%d",++rule,1);
 printf(", a%d",$1);
 printf("]\n");
 $$=rule; };
expr : expr '+' expr %prec PRIORITY2  { 
 printf("a%d = [%d",++rule,2);
 printf(", a%d",$1);
 printf(", a%d",$3);
 printf("]\n");
 $$=rule; };
expr : expr '-' expr %prec PRIORITY2  { 
 printf("a%d = [%d",++rule,3);
 printf(", a%d",$1);
 printf(", a%d",$3);
 printf("]\n");
 $$=rule; };
expr : expr '*' expr %prec PRIORITY1  { 
 printf("a%d = [%d",++rule,4);
 printf(", a%d",$1);
 printf(", a%d",$3);
 printf("]\n");
 $$=rule; };
expr : expr '/' expr %prec PRIORITY1  { 
 printf("a%d = [%d",++rule,5);
 printf(", a%d",$1);
 printf(", a%d",$3);
 printf("]\n");
 $$=rule; };
expr : NUMBER  { 
 printf("a%d = [%d",++rule,6);
 print_str((str*)$1);
 printf("]\n");
 $$=rule; };

%%
int yyerror(char *s) {
	//is_error = 1;
	fprintf(stderr, "error, line %d: %s\n", yylineno, s);
	return 0;
}

int main(int argc, char **argv) {
	yyparse();
	return 0;
}

#include "lex.yy.c"
